namespace VUtils {

//http://stackoverflow.com/questions/1701055/what-is-the-maximum-length-in-chars-needed-to-represent-any-double-value
const int MAX_FLOAT_CHARS = 3 + FLT_MANT_DIG - FLT_MIN_EXP; 

AColor inline userAttrParseAColor(const tchar* attr_str) {
	AColor ret(0.0f, 0.0f, 0.0f, 0.0f);
	const int bufSize=4*MAX_FLOAT_CHARS;	// temp buffer for parsing - we must parse max 4 numbers, so we can assume that this buffer is enough
	tchar tmp[bufSize];
	tchar floatBuf[MAX_FLOAT_CHARS]=""; //temp buffer for changing the decimal separator
	strncpy(tmp, attr_str, bufSize-1); tmp[bufSize-1] = 0;
	tchar *str = tmp;
	// try to parse the string into several numbers
	tchar *p = str;
	int count = 0;
	while (1) {
		p = strchr(p, ',');
		if (!p)
			break;
		*p = 0; p++;
		count++;
	}
	
	count++; // we have <commas + 1> numbers
	// convert the numbers to floats
	if (count > 4) count = 4;
	p = str;
	for (int i=0; ;) {
		localizeNumString(p,floatBuf);
		ret[i] = (float)atof(floatBuf);
		i++;
		if (i<count) {
			p += strlen(p) + 1;
			// restore the comma
			//*(p-1) = ',';
		}
		else break;
	}
	switch (count) {
		case 1: ret[1] = ret[2] = ret[0]; ret[3] = 1.f; break;
		case 2: ret[2] = 0.f; ret[3] = 1.f; break;
		case 3: ret[3] = 1.f; break;
		default: /*always >0 and <=4. For 4 we have nothing to do */ break;
	}
	return ret;
}

float	inline userAttrParseFloat(const tchar* attr_str) {
	float ret=0.0f;	
	const int bufSize=4*MAX_FLOAT_CHARS;	// temp buffer for parsing - we must parse max 4 numbers, so we can assume that this buffer is enough
	tchar tmp[bufSize]; // we must parse max 4 numbers, so we can assume that this buffer is enough
	tchar floatBuf[MAX_FLOAT_CHARS]=""; //temp buffer for changing the decimal separator
	strncpy(tmp, attr_str, bufSize-1); tmp[bufSize-1] = 0;
	tchar *str = tmp;
	// try to parse the string into several numbers
	tchar *p = str;
	int count = 0;
	while (1) {
		p = strchr(p, ',');
		if (!p)
			break;
		*p = 0; p++;
		count++;
	}
	
	count++; // we have <commas + 1> numbers
	// convert the numbers to floats
	if (count > 4) count = 4;
	p = str;
	float val[4];
	for (int i=0; ;) {
		localizeNumString(p,floatBuf);
		val[i] = (float)atof(floatBuf);
		i++;
		if (i<count) {
			p += strlen(p) + 1;
			// restore the comma
			//*(p-1) = ',';
		}
		else break;
	}
	switch (count) {
		case 1: ret = val[0]; break;
		case 2: ret = 0.5f*(val[0]+val[1]); break;
		case 3: ret = (val[0]+val[1]+val[2])*(1.0f/3.0f); break;
		case 4: ret = val[3]; break;
		default: /*always >0 and <=4.*/ break;
	}	
	return ret;
}

}